%global flavor gcc32winthr
%global enable64 no

%global __strip %{_mingw32_strip}
%global __objdump %{_mingw32_objdump}
%global _use_internal_dependency_generator 0
%global __find_requires %{_mingw32_findrequires}
%global __find_provides %{_mingw32_findprovides}

%global oname globus-core
%global _name %(tr - _ <<< %{oname})

Name:		mingw32-%{oname}
Version:	5.15
Release:	1%{?dist}
Summary:	Globus Toolkit for MinGW - Globus Core

Group:		Development/Libraries
License:	ASL 2.0
URL:		http://www.globus.org/
#		Source is extracted from the globus toolkit installer:
#		wget -N http://www-unix.globus.org/ftppub/gt4/4.2.1/installers/src/gt4.2.1-all-source-installer.tar.bz2
#		tar -jxf gt4.2.1-all-source-installer.tar.bz2
#		mv gt4.2.1-all-source-installer/source-trees/core/source globus_core-5.15
#		tar -zcf globus_core-5.15.tar.gz globus_core-5.15
Source:		%{_name}-%{version}.tar.gz
#		GPT metadata to pkg-config file converter
Source1:	mingw32-globus-gpt2pkg-config
#		Make file locations configurable:
#		http://bugzilla.globus.org/bugzilla/show_bug.cgi?id=6451
Patch0:		%{oname}-conf.patch
#		Environment variable elimination patch:
#		http://bugzilla.globus.org/bugzilla/show_bug.cgi?id=6452
Patch1:		%{oname}-usr.patch
#		Missing functions in configure check:
#		http://bugzilla.globus.org/bugzilla/show_bug.cgi?id=6453
Patch2:		%{oname}-func.patch
#		Detect IOV_MAX correctly (requires _GNU_SOURCE):
#		http://bugzilla.globus.org/bugzilla/show_bug.cgi?id=6454
Patch3:		%{oname}-gnusource.patch
#		Make GPT_AGE_VERSION available to autotools:
#		http://bugzilla.globus.org/bugzilla/show_bug.cgi?id=6455
Patch4:		%{oname}-age-version.patch
#		Missing shebang:
#		http://bugzilla.globus.org/bugzilla/show_bug.cgi?id=6456
Patch5:		%{oname}-bootstrap-shebang.patch
#		Make configure --help look nice:
#		http://bugzilla.globus.org/bugzilla/show_bug.cgi?id=6457
Patch6:		%{oname}-helpstring.patch
#		Fix doxygen documentation installation instructions:
#		http://bugzilla.globus.org/bugzilla/show_bug.cgi?id=6458
Patch7:		%{oname}-doxygen.patch
#		Make it work with older and newer automake versions:
#		http://bugzilla.globus.org/bugzilla/show_bug.cgi?id=6565
Patch8:		%{oname}-compat.patch
#		Avoid race condition when renaming the libtool file:
#		http://bugzilla.globus.org/bugzilla/show_bug.cgi?id=6575
Patch9:		%{oname}-libtool.patch
#		Properly propagate $AR and $RANLIB:
#		http://bugzilla.globus.org/bugzilla/show_bug.cgi?id=6739
Patch10:	%{oname}-ar-ranlib.patch
#		Fixes for mingw compilation:
#		http://bugzilla.globus.org/bugzilla/show_bug.cgi?id=6742
Patch11:	%{oname}-mingw.patch
#		Fix build configuration for s390x and kfreebsd:
#		http://bugzilla.globus.org/bugzilla/show_bug.cgi?id=6754
Patch12:	%{oname}-platforms.patch
#		Adapt dependency script to Fedora's documentation location:
#		Not relevant for upstream - not submitted to globus bugzilla
Patch13:	%{oname}-fedora.patch
BuildArch:	noarch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

Requires:	pkgconfig
Requires:	perl(XML::DOM)
Requires:	perl(XML::Parser)
BuildRequires:	grid-packaging-tools
BuildRequires:	perl(XML::DOM)
BuildRequires:	perl(XML::Parser)
BuildRequires:	mingw32-filesystem
BuildRequires:	mingw32-gcc

%description
The Globus Toolkit is an open source software toolkit used for building Grid
systems and applications. It is being developed by the Globus Alliance and
many others all over the world. A growing number of projects and companies are
using the Globus Toolkit to unlock the potential of grids for their cause.

The %{name} package contains:
Globus Core

%prep
%setup -q -n %{_name}-%{version}
%patch0 -p1 -b .conf
%patch1 -p1 -b .usr
%patch2 -p1 -b .func
%patch3 -p1 -b .gnusource
%patch4 -p1 -b .age
%patch5 -p1 -b .shebang
%patch6 -p1 -b .help
%patch7 -p1 -b .doxygen
%patch8 -p1 -b .compat
%patch9 -p1 -b .libtool
%patch10 -p1 -b .ranlib
%patch11 -p1 -b .mingw
%patch12 -p1 -b .platform
%patch13 -p1 -b .fedora

%build
export GLOBUS_LOCATION=%{_mingw32_prefix}

# Remove files that should be replaced during bootstrap
rm -rf autom4te.cache

./bootstrap

# The globus-core configure chokes if AR, CC, LD etc are defined as absolute
# paths - modify the configure macro to use the program names only
%define _mingw32_configure %(rpm -E %%_mingw32_configure | sed 's!"$i"!`sed s:/usr/bin/:: <<< "$i"`!')

# Configure gets these wrong for mingw
export ac_cv_func_gethostname=yes
export ac_cv_func_gethostbyaddr=yes
export ac_cv_func_getaddrinfo=yes
export ac_cv_func_getnameinfo=yes
export ac_cv_func_getservbyname=yes
export ac_cv_func_getprotobynumber=yes
export ac_cv_func_inet_ntoa=yes
export ac_cv_func_inet_addr=yes
export ac_cv_func_freeaddrinfo=yes
export ac_cv_func_gai_strerror=yes

# Libtool DLL magic
export LDFLAGS="-no-undefined -Wl,--export-all-symbols -Wl,--enable-auto-import -Wl,--enable-runtime-pseudo-reloc"

%_mingw32_configure --includedir='${prefix}/include/globus' \
		    --libexecdir='${datadir}/globus' \
		    --with-threads=windows \
		    --with-flavor=%{flavor} \
		    --enable-64bit=%{enable64} \
		    --with-setupdir='${datadir}/globus/setup' \
		    --with-testdir='${datadir}/globus/test/${PACKAGE}' \
		    --with-flavorincludedir='${libdir}/globus/include' \
		    --with-doxygendir='${datadir}/globus/doxygen' \
		    --with-newgpt

make %{?_smp_mflags}

%install
export GLOBUS_LOCATION=%{_mingw32_prefix}

rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT

# These scripts are intended to be sourced, not executed
chmod 644 $RPM_BUILD_ROOT%{_mingw32_datadir}/globus/globus-build-env-*.sh

GLOBUSPACKAGEDIR=$RPM_BUILD_ROOT%{_mingw32_datadir}/globus/packages

# Add -Wl,--as-needed to the libtool script
sed 's! -shared ! \\\${wl}--as-needed&!g' \
  -i $RPM_BUILD_ROOT%{_mingw32_sbindir}/libtool-%{flavor}

# Install the GPT metadata to pkg-config file converter
install %SOURCE1 \
  $RPM_BUILD_ROOT%{_mingw32_datadir}/globus/mingw32-globus-gpt2pkg-config

# Generate pkg-config file from GPT metadata
mkdir -p $RPM_BUILD_ROOT%{_mingw32_libdir}/pkgconfig
$RPM_BUILD_ROOT%{_mingw32_datadir}/globus/mingw32-globus-gpt2pkg-config \
  pkgdata/pkg_data_%{flavor}_dev.gpt > \
  $RPM_BUILD_ROOT%{_mingw32_libdir}/pkgconfig/%{oname}.pc

# Remove license file installed directly in the buildroot
rm -f $RPM_BUILD_ROOT/$GLOBUS_LOCATION/GLOBUS_LICENSE
sed /GLOBUS_LICENSE/d -i $GLOBUSPACKAGEDIR/%{_name}/noflavor_data.filelist

# Install license file
mkdir -p $RPM_BUILD_ROOT%{_mingw32_docdir}/%{name}-%{version}
install -m 644 -p GLOBUS_LICENSE \
  $RPM_BUILD_ROOT%{_mingw32_docdir}/%{name}-%{version}

# Generate package filelists
cat $GLOBUSPACKAGEDIR/%{_name}/%{flavor}_pgm.filelist \
    $GLOBUSPACKAGEDIR/%{_name}/%{flavor}_rtl.filelist \
    $GLOBUSPACKAGEDIR/%{_name}/%{flavor}_dev.filelist \
    $GLOBUSPACKAGEDIR/%{_name}/noflavor_data.filelist \
  | sed s!^!%{_mingw32_prefix}! > package.filelist

%clean
rm -rf $RPM_BUILD_ROOT

%files -f package.filelist
%defattr(-,root,root,-)
%dir %{_mingw32_datadir}/globus
%dir %{_mingw32_datadir}/globus/aclocal
%dir %{_mingw32_datadir}/globus/doxygen
%dir %{_mingw32_datadir}/globus/flavors
%dir %{_mingw32_datadir}/globus/packages
%dir %{_mingw32_datadir}/globus/packages/%{_name}
%dir %{_mingw32_libdir}/globus
%dir %{_mingw32_libdir}/globus/include
%{_mingw32_libdir}/pkgconfig/%{oname}.pc
%{_mingw32_datadir}/globus/mingw32-globus-gpt2pkg-config
%dir %{_mingw32_docdir}/%{name}-%{version}
%doc %{_mingw32_docdir}/%{name}-%{version}/GLOBUS_LICENSE

%changelog
* Wed May  6 2009 Mattias Ellert <mattias.ellert@fysast.uu.se> - 5.15-1
- Autogenerated
